/////////////////////////////////////////////////////////////////////////////////////////////
// Copyright 2024 Garmin International, Inc.
// Licensed under the Flexible and Interoperable Data Transfer (FIT) Protocol License; you
// may not use this file except in compliance with the Flexible and Interoperable Data
// Transfer (FIT) Protocol License.
/////////////////////////////////////////////////////////////////////////////////////////////
// ****WARNING****  This file is auto-generated!  Do NOT edit this file.
// Profile Version = 21.133.0Release
// Tag = production/release/21.133.0-0-g6002091
/////////////////////////////////////////////////////////////////////////////////////////////


package com.garmin.fit;



public class HsaGyroscopeDataMesg extends Mesg   {

    
    public static final int TimestampFieldNum = 253;
    
    public static final int TimestampMsFieldNum = 0;
    
    public static final int SamplingIntervalFieldNum = 1;
    
    public static final int GyroXFieldNum = 2;
    
    public static final int GyroYFieldNum = 3;
    
    public static final int GyroZFieldNum = 4;
    
    public static final int Timestamp32kFieldNum = 5;
    

    protected static final  Mesg hsaGyroscopeDataMesg;
    static {
        // hsa_gyroscope_data
        hsaGyroscopeDataMesg = new Mesg("hsa_gyroscope_data", MesgNum.HSA_GYROSCOPE_DATA);
        hsaGyroscopeDataMesg.addField(new Field("timestamp", TimestampFieldNum, 134, 1, 0, "s", false, Profile.Type.DATE_TIME));
        
        hsaGyroscopeDataMesg.addField(new Field("timestamp_ms", TimestampMsFieldNum, 132, 1, 0, "ms", false, Profile.Type.UINT16));
        
        hsaGyroscopeDataMesg.addField(new Field("sampling_interval", SamplingIntervalFieldNum, 132, 1, 0, "1/32768 s", false, Profile.Type.UINT16));
        
        hsaGyroscopeDataMesg.addField(new Field("gyro_x", GyroXFieldNum, 131, 28.57143, 0, "deg/s", false, Profile.Type.SINT16));
        
        hsaGyroscopeDataMesg.addField(new Field("gyro_y", GyroYFieldNum, 131, 28.57143, 0, "deg/s", false, Profile.Type.SINT16));
        
        hsaGyroscopeDataMesg.addField(new Field("gyro_z", GyroZFieldNum, 131, 28.57143, 0, "deg/s", false, Profile.Type.SINT16));
        
        hsaGyroscopeDataMesg.addField(new Field("timestamp_32k", Timestamp32kFieldNum, 134, 1, 0, "1/32768 s", false, Profile.Type.UINT32));
        
    }

    public HsaGyroscopeDataMesg() {
        super(Factory.createMesg(MesgNum.HSA_GYROSCOPE_DATA));
    }

    public HsaGyroscopeDataMesg(final Mesg mesg) {
        super(mesg);
    }


    /**
     * Get timestamp field
     * Units: s
     *
     * @return timestamp
     */
    public DateTime getTimestamp() {
        return timestampToDateTime(getFieldLongValue(253, 0, Fit.SUBFIELD_INDEX_MAIN_FIELD));
    }

    /**
     * Set timestamp field
     * Units: s
     *
     * @param timestamp The new timestamp value to be set
     */
    public void setTimestamp(DateTime timestamp) {
        setFieldValue(253, 0, timestamp.getTimestamp(), Fit.SUBFIELD_INDEX_MAIN_FIELD);
    }

    /**
     * Get timestamp_ms field
     * Units: ms
     * Comment: Millisecond resolution of the timestamp
     *
     * @return timestamp_ms
     */
    public Integer getTimestampMs() {
        return getFieldIntegerValue(0, 0, Fit.SUBFIELD_INDEX_MAIN_FIELD);
    }

    /**
     * Set timestamp_ms field
     * Units: ms
     * Comment: Millisecond resolution of the timestamp
     *
     * @param timestampMs The new timestampMs value to be set
     */
    public void setTimestampMs(Integer timestampMs) {
        setFieldValue(0, 0, timestampMs, Fit.SUBFIELD_INDEX_MAIN_FIELD);
    }

    /**
     * Get sampling_interval field
     * Units: 1/32768 s
     * Comment: Sampling Interval in 32 kHz timescale
     *
     * @return sampling_interval
     */
    public Integer getSamplingInterval() {
        return getFieldIntegerValue(1, 0, Fit.SUBFIELD_INDEX_MAIN_FIELD);
    }

    /**
     * Set sampling_interval field
     * Units: 1/32768 s
     * Comment: Sampling Interval in 32 kHz timescale
     *
     * @param samplingInterval The new samplingInterval value to be set
     */
    public void setSamplingInterval(Integer samplingInterval) {
        setFieldValue(1, 0, samplingInterval, Fit.SUBFIELD_INDEX_MAIN_FIELD);
    }

    public Float[] getGyroX() {
        
        return getFieldFloatValues(2, Fit.SUBFIELD_INDEX_MAIN_FIELD);
        
    }

    /**
     * @return number of gyro_x
     */
    public int getNumGyroX() {
        return getNumFieldValues(2, Fit.SUBFIELD_INDEX_MAIN_FIELD);
    }

    /**
     * Get gyro_x field
     * Units: deg/s
     * Comment: X-Axis Measurement
     *
     * @param index of gyro_x
     * @return gyro_x
     */
    public Float getGyroX(int index) {
        return getFieldFloatValue(2, index, Fit.SUBFIELD_INDEX_MAIN_FIELD);
    }

    /**
     * Set gyro_x field
     * Units: deg/s
     * Comment: X-Axis Measurement
     *
     * @param index of gyro_x
     * @param gyroX The new gyroX value to be set
     */
    public void setGyroX(int index, Float gyroX) {
        setFieldValue(2, index, gyroX, Fit.SUBFIELD_INDEX_MAIN_FIELD);
    }

    public Float[] getGyroY() {
        
        return getFieldFloatValues(3, Fit.SUBFIELD_INDEX_MAIN_FIELD);
        
    }

    /**
     * @return number of gyro_y
     */
    public int getNumGyroY() {
        return getNumFieldValues(3, Fit.SUBFIELD_INDEX_MAIN_FIELD);
    }

    /**
     * Get gyro_y field
     * Units: deg/s
     * Comment: Y-Axis Measurement
     *
     * @param index of gyro_y
     * @return gyro_y
     */
    public Float getGyroY(int index) {
        return getFieldFloatValue(3, index, Fit.SUBFIELD_INDEX_MAIN_FIELD);
    }

    /**
     * Set gyro_y field
     * Units: deg/s
     * Comment: Y-Axis Measurement
     *
     * @param index of gyro_y
     * @param gyroY The new gyroY value to be set
     */
    public void setGyroY(int index, Float gyroY) {
        setFieldValue(3, index, gyroY, Fit.SUBFIELD_INDEX_MAIN_FIELD);
    }

    public Float[] getGyroZ() {
        
        return getFieldFloatValues(4, Fit.SUBFIELD_INDEX_MAIN_FIELD);
        
    }

    /**
     * @return number of gyro_z
     */
    public int getNumGyroZ() {
        return getNumFieldValues(4, Fit.SUBFIELD_INDEX_MAIN_FIELD);
    }

    /**
     * Get gyro_z field
     * Units: deg/s
     * Comment: Z-Axis Measurement
     *
     * @param index of gyro_z
     * @return gyro_z
     */
    public Float getGyroZ(int index) {
        return getFieldFloatValue(4, index, Fit.SUBFIELD_INDEX_MAIN_FIELD);
    }

    /**
     * Set gyro_z field
     * Units: deg/s
     * Comment: Z-Axis Measurement
     *
     * @param index of gyro_z
     * @param gyroZ The new gyroZ value to be set
     */
    public void setGyroZ(int index, Float gyroZ) {
        setFieldValue(4, index, gyroZ, Fit.SUBFIELD_INDEX_MAIN_FIELD);
    }

    /**
     * Get timestamp_32k field
     * Units: 1/32768 s
     * Comment: 32 kHz timestamp
     *
     * @return timestamp_32k
     */
    public Long getTimestamp32k() {
        return getFieldLongValue(5, 0, Fit.SUBFIELD_INDEX_MAIN_FIELD);
    }

    /**
     * Set timestamp_32k field
     * Units: 1/32768 s
     * Comment: 32 kHz timestamp
     *
     * @param timestamp32k The new timestamp32k value to be set
     */
    public void setTimestamp32k(Long timestamp32k) {
        setFieldValue(5, 0, timestamp32k, Fit.SUBFIELD_INDEX_MAIN_FIELD);
    }

}
