/////////////////////////////////////////////////////////////////////////////////////////////
// Copyright 2024 Garmin International, Inc.
// Licensed under the Flexible and Interoperable Data Transfer (FIT) Protocol License; you
// may not use this file except in compliance with the Flexible and Interoperable Data
// Transfer (FIT) Protocol License.
/////////////////////////////////////////////////////////////////////////////////////////////
// ****WARNING****  This file is auto-generated!  Do NOT edit this file.
// Profile Version = 21.133.0Release
// Tag = production/release/21.133.0-0-g6002091
/////////////////////////////////////////////////////////////////////////////////////////////


class AccumulatedField {
    #accumulatedValue = 0;
    #lastValue = 0;

    constructor(value) {
        this.#accumulatedValue = value;
        this.#lastValue = value;
    }

    accumulate(value, bits) {
        const mask = (1 << bits) - 1;

        this.#accumulatedValue += (value - this.#lastValue) & mask;
        this.#lastValue = value;

        return this.#accumulatedValue;
    }
}

class Accumulator {
    #messages = {};

    add(mesgNum, fieldNum, value) {
        if (this.#messages[mesgNum] == null) {
            this.#messages[mesgNum] = {};
        }

        this.#messages[mesgNum][fieldNum] = new AccumulatedField(value);
    }

    accumulate(mesgNum, fieldNum, value, bits) {
        return this.#messages[mesgNum]?.[fieldNum]?.accumulate(value, bits) ?? value;
    }
}

export default Accumulator;
